<!--  
 * This file is part of the SecureFlag Platform.
 * Copyright (c) 2020 SecureFlag Limited.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 -->
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="SecureFlag">
<title>SecureFlag - Portal</title>
<link rel="icon" type="image/png" sizes="96x96"
	href="/assets/img/favicon-96x96.png">
<link href="/assets/css/lib.css" rel="stylesheet">
<link href="/assets/css/style.css" rel="stylesheet">
</head>
<body>
	<div ng-app="sfNg">
		<div ng-controller="navigation">
			<div class="navbar navbar-default navbar-fixed-top noBorderBottom maxHeight60 sfNavbarN"
				role="navigation">
				<div>
					<div class="navbar-header ">
						<li class="pull-left marginLeft1P hideUncollapsed"><img src="/assets/img/sfhn.png" class="sfNavbarLogo" /><span class="sfce">CE</span></li>

						<li
							class="pull-right marginRight1P hideUncollapsed marginTop15 marginLeft15"><a
							class="navbarI white" href="" ng-click="logout()"><i
								class="fa fa-sign-out fa-lg white" aria-hidden="true"></i></a></li>
						<li class="pull-right hideUncollapsed marginTop15"
							ng-class="{'active' : visibility.settings }"><a
							class="navbarI white" href="#settings"><i
								class="fa fa-cogs fa-lg white" aria-hidden="true"></i></a></li>
						<button type="button" class="navbar-toggle navbar-toggle-user collapsed"
							data-toggle="collapse" data-target="#sfNavbar"
							aria-expanded="false">
							<span class="sr-only">Toggle navigation</span> <span
								class="icon-bar"></span> <span class="icon-bar"></span> <span
								class="icon-bar"></span>
						</button>
					</div>
					<div class="navbar-collapse user-collapse" id="sfNavbar">
						<ul class="nav navbar-nav collapsedOverflow">
							<li class="pull-left marginLeft1P hideCollapsed"><img src="/assets/img/sfhn.png" class="sfNavbarLogo" /><span class="sfce">CE</span></li>

							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.dashboard }"><a
								class="navbarA " href="#dashboard">DASHBOARD</a></li>
							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.assignedExercises }"><a
								class="navbarA " href="#exercises">EXERCISES</a></li>
							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.challenges }" class="ng-cloak"><a
								class="navbarA" href="#tournaments">TOURNAMENTS</a></li>
							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.runningExercises }"><a
								class="navbarA" href="#running" id="runningNavigation"> <notification-icon
										animation="grow"
										count="crashedInstances.length + runningInstances.length">RUNNING
									EXERCISES</notification-icon>
							</a></li>
							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.history }"><a
								class="navbarA" href="#history">COMPLETED EXERCISES</a></li>
							<li class="paddingRight10 paddingLeft10"
								ng-class="{'active' : visibility.achievements }"><a
								class="navbarA" href="#achievements">ACHIEVEMENTS & STATS</a></li>
							<li class="paddingRight10 paddingLeft10" ng-show="user.team.name"
								ng-class="{'active' : visibility.leaderboard }"><a
								class="navbarA" href="#leaderboard">TEAM</a></li>
							<li class="pull-right marginRight1P hideCollapsed font12"><a
								class="navbarI" href="" ng-click="logout()"><i
									class="fa fa-sign-out fa-lg white" aria-hidden="true"></i></a></li>
							<li class="pull-right hideCollapsed font12"
								ng-class="{'active' : visibility.settings }"><a
								class="navbarI" href="#settings"><i class="fa fa-cogs fa-lg white"
									aria-hidden="true"></i></a></li>
							<li ng-show="userCredits!='-1'" class="pull-right hideCollapsed font12"><a
								class="navbarI btn notificationcentre blackBackground dropdown-toggle maxHeight50"
								href="" id="dropdownMenuLink2" data-toggle="dropdown"
								aria-haspopup="true" aria-expanded="false" href="" id="" href="">
									<notification-icon animation="grow" count="userCredits">
									<i class="fa white fa-ticket fa-lg"></i></notification-icon>
							</a>
								<div
									class="notificationcentre  notificationCentreDropdown dropdown-menu"
									aria-labelledby="dropdownMenuLink2">
									<a class="dropdown-item" href="">
										<div class="">
											<span class="notificationText">Each exercise you run
												costs one credit. You have <strong>{{userCredits}} credits</strong> left.</span>
										</div>
									</a>
								</div></li>


							<li class="pull-right hideCollapsed"><a
								class="navbarI btn notificationcentre blackBackground dropdown-toggle maxHeight50 font12"
								href="" id="dropdownMenuLink" data-toggle="dropdown"
								aria-haspopup="true" aria-expanded="false" href=""><notification-icon
										animation="grow" count="notifications.length">
									<i class="fa fa-envelope-o fa-lg white"></i></notification-icon></a>
								<div
									class="notificationcentre notificationCentreDropdown dropdown-menu"
									aria-labelledby="dropdownMenuLink">
									<a ng-show="notifications.length <= 0" class="dropdown-item"
										href="">
										<div class="">
											<span class="notificationText">No unread notifications</span>
										</div>
									</a> <a ng-show="notifications.length >= 2"
										class="dropdown-item centered" href=""> <i
										class="fa fa-times dismissNotificationIcon" aria-hidden="true"><span
											ng-click="markAllNotificationsRead()"
											class="dismissAll dismissNotificationSpan">Dismiss all
												notifications</span></i></a> <a
										ng-repeat="n in notifications | orderBy:'-id'"
										class="dropdown-item" href="">
										<div ng-click="goTo(n.link)" class="notificationHoverable">
											<i ng-click="goTo(n.link)" class="fa fa-bell"
												aria-hidden="true"></i> <span class="notificationText">{{n.text}}</span>
										</div>

										<div ng-click="markNotificationRead(n.id)"
											class="dismissNotification ">
											<i class="fa fa-times dismissNotificationIcon"
												aria-hidden="true"><span
												ng-click="markNotificationRead(n.id)"
												class="dismissNotificationSpan">Dismiss</span></i>
											<div class="notificationDate">{{getDateInCurrentTimezone(n.date,
												"MMM D YYYY, HH:mm")}}</div>
										</div>
									</a>

								</div></li>

						</ul>
					</div>
				</div>
				<div class="widget-main-header"></div>
			</div>


			<div id="dashboard" class="ng-cloak standalone" ng-controller="dashboard"
				ng-show="visibility.dashboard">

				<div class="widget-grid-container paddingTop15">
					<main class="widget-main">

					<div class="widget-main-overview row hide990 font17">
						<div class="col-md-2 col-md-offset-1">
							<a href="#achievements"><div class="widget-overviewcard">
									<div class="widget-overviewcard-icon">
										<img class="dashboardPicture"
											src="/assets/img/vulnerability.svg" />
									</div>
									<div class="widget-overviewcard-subtitle">Run Exercises</div>
									<div class="">
										<strong>{{userAchievements.exercisesRun}}</strong>
									</div>
								</div></a>
						</div>
						<div class="col-md-2">
							<a href="#achievements"><div class="widget-overviewcard">
									<div class="widget-overviewcard-icon">
										<img class="dashboardPicture" src="/assets/img/score.png" />
									</div>
									<div class="widget-overviewcard-subtitle">Points</div>
									<div class="">
										<strong>{{userAchievements.score}}</strong>
									</div>
								</div></a>
						</div>
						<div class="col-md-2">
							<a href="#achievements"><div class="widget-overviewcard">
									<div class="widget-overviewcard-icon">
										<img class="dashboardPicture" src="/assets/img/trophy.svg" />
									</div>
									<div class="widget-overviewcard-subtitle">Trophies</div>
									<div class="">
										<strong>{{trophies.length}}</strong>
									</div>
								</div></a>
						</div>
						<div class="col-md-2">
							<a href="#achievements"><div class="widget-overviewcard">
									<div class="widget-overviewcard-icon">
										<img class="dashboardPicture" src="/assets/img/cert.svg" />
									</div>

									<div class="widget-overviewcard-subtitle">Certifications</div>
									<div class="">
										<strong>{{certifications.length}}</strong>
									</div>
								</div></a>
						</div>
						<div class="col-md-2">
							<a href="#achievements"><div class="widget-overviewcard">
									<div class="marginLeft5 widget-overviewcard-icon">
										<img class="dashboardPicture" src="/assets/img/placement.png" />
									</div>

									<div class="widget-overviewcard-subtitle">Tournament
										Badges</div>
									<div class="">
										<strong>{{placements.length}}</strong>
									</div>
								</div></a>
						</div>
					</div>


					<div class="widget-main-cards row">
						<div class="col-md-6">

							<div class="widget-card h165 overflowHidden">
								<div class="card__header">
									<div class="card__header-title text-light flexRow">
										<div class="flexCol-70">Running Exercises</div>
										<div class="flexCol-30 right">
											<a href="#running"
												class="card__header-link text-bold font12 marginTop2"><small>View
													Running Exercises</small></a>
										</div>

									</div>

								</div>
								<div class="a100PC">
									<div class="emptyDash" ng-show="latestRunning.length==0">There
										are no running exercises.</div>
									<table class="table font12" ng-show="latestRunning.length>0">
										<thead>
											<tr>
												<th class="paddingLeft15">Exercise</th>
												<th>Tech.</th>
												<th>Current Score</th>
												<th>EndTime</th>
												<th></th>
											</tr>
										</thead>
										<tbody>
											<tr ng-repeat="item in latestRunning">
												<td class="paddingLeft15">{{item.title}}</td>
												<td>{{item.technology}}</td>
												<td class="center">{{getCurrentScore(item.score.result)}}</td>
												<td>{{getDateInCurrentTimezone(item.endTime,'MMM D YYYY
													HH:mm')}}</td>
												<td><a href="#running"
													class="btn btn-success btn-xs outline">Resume</a></td>
											</tr>
										</tbody>
									</table>

								</div>
							</div>
							<div class="widget-card h165 overflowHidden">
								<div class="card__header">
									<div class="flexRow card__header-title text-light">
										<div class="flexCol-70">Active Tournaments</div>
										<div class="flexCol-30 right">
											<a href="#tournaments"
												class="card__header-link text-bold marginTop2 font12"><small>View
													Tournaments</small></a>
										</div>

									</div>

								</div>
								<div class="a100PC">
									<div class="emptyDash" ng-show="recentChallenges.length==0">There
										are no active tournaments.</div>
									<table id="activeTournamentsTable" ng-show="recentChallenges.length>0" class="table font12">
										<thead>
											<tr>
												<th class="paddingLeft15">Tournament</th>
												<th class="ellipsis"># Exercises</th>
												<th class="ellipsis"># Users</th>
												<th>Completion</th>
												<th>End Time</th>
												<th></th>
											</tr>
										</thead>
										<tbody>
											<tr ng-repeat="item in recentChallenges">
												<td class="paddingLeft15">{{item.name}}</td>
												<td class="center">{{item.scopeExercises.length}}</td>
												<td class="center">{{item.users.length}}</td>
												<td ng-class="getClassForCompletion(item.completion)"
													class="center">{{item.completion | number: 1}}%</td>
												<td>{{getDateInCurrentTimezone(item.endDate,'MMM D YYYY
													HH:mm')}}</td>
												<td><a href="#/tournaments/details/{{item.id}}"
													class="btn btn-primary btn-xs outline">View</a></td>
											</tr>
										</tbody>
									</table>

								</div>
							</div>


							<div class="widget-card h360">
								<div class="card__header">
									<div class="card__header-title text-light flexRow">
										<div class="flexCol-70">Remediation Metrics</div>
										<div class="flexCol-30 right">
											<a href="#achievements"
												class="card__header-link text-bold marginTop2 font12"><small>View
													Stats</small></a>
										</div>
									</div>


								</div>
								<div class="a85PC paddingTop10">
									<div class="emptyDash"
										ng-show="userRemediation.labels.length<=2">There are no
										stats available for you yet.</div>
									<canvas ng-show="userRemediation.labels.length>2"
										id="userRemediation" class="chart chart-radar"
										chart-data="userRemediation.data"
										chart-series="userRemediation.series"
										chart-options="userRemediation.options"
										chart-labels="userRemediation.labels">
								</canvas>

								</div>

							</div>

						</div>
						<div class="col-md-6">
							<div class="widget-card h350">
								<div class="card__header">
									<div class="card__header-title text-light flexRow">
										<div class="flexCol-70">Score and Duration by Exercise</div>
										<div class="flexCol-30 right">
											<a href="#achievements"
												class="card__header-link text-bold marginTop2 font12"><small>View
													Stats</small></a>
										</div>
									</div>

								</div>
								<div class="a85PC">
									<div class="emptyDash" ng-show="latestStats.labels.length==0">There
										are no stats available for your profile yet.</div>
									<canvas ng-show="latestStats.labels.length>0"
										id="latestHistory" class="chart chart-line"
										chart-data="latestStats.data"
										chart-labels="latestStats.labels"
										chart-series="latestStats.series"
										chart-dataset-override="latestStats.datasetOverride"
										chart-options="latestStats.options">
							</canvas>
								</div>
							</div>



							<div class="widget-card h360 overflowHidden">
								<div class="card__header">
									<div class="card__header-title text-light flexRow">
										<div class="flexCol-70">Latest Completed Exercises</div>
										<div class="flexCol-30 right">
											<a href="#history"
												class="card__header-link text-bold marginTop2 font12"><small>View
													Completed Exercises</small></a>
										</div>
									</div>
								</div>
								<div class="a100PC">
									<div class="emptyDash" ng-show="latestExercises.length==0">You
										haven't completed any exercise yet.</div>

									<table id="latestExercisesTable" ng-show="latestExercises.length>0" class="table font12">
										<thead>
											<tr>
												<th>Exercise</th>
												<th>Tech.</th>
												<th>Date / Duration</th>
												<th>Score</th>
												<th></th>
											</tr>
										</thead>
										<tbody>
											<tr ng-repeat="item in latestExercises | orderBy:'-item.id'">
												<td>{{item.title}}</td>
												<td>{{item.technology}}</td>
												<td>{{getDateInCurrentTimezone(item.startTime, 'MMM D
													YYYY
													HH:mm')}}&nbsp;({{getDurationInterval(item.startTime,item.endTime,item.duration)}})</td>
												<td
													ng-class="getResultsScoreClass(item.score.result,item.score.total, item.status)"
													class="right">{{ getResultsScore(item.score)
													}}/{{item.score.total}}</td>
												<td><a href="#history/details/{{item.id}}"
													class="btn btn-xs btn-primary outline">View</a></td>
											</tr>
										</tbody>
									</table>

								</div>
							</div>
						</div>
					</div>
					</main>
				</div>

			</div>

			<!-- *****************************************************************************************************************
	 HEADERWRAP
	 ***************************************************************************************************************** -->
		</div>
		<div id="headerwrap" class="ng-cloak" ng-show="visibility.welcome"
			ng-controller="welcome"></div>
		<!-- *****************************************************************************************************************
	 USER MENU OPTIONS
	 ***************************************************************************************************************** -->
		<div id="service" class="ng-cloak" ng-show="visibility.home"
			ng-controller="home">
			<div class="container serviceContainer">
				<div class="row centered serviceInnerContainer col-md-12">
					<div class="col-md-4">
						<a href="#exercises"><i class="fa fa-flask"></i></a>
						<h4>
							<a href="#exercises">Exercises</a>
						</h4>
						<p>Browse exercises and start hacking.</p>
					</div>
					<div class="col-md-4">
						<a href="#achievements"><i class="fa fa-trophy"></i></a>
						<h4>
							<a href="#achievements">Achievements & Stats</a>
						</h4>
						<p>Look at achievements, stats and score.</p>
					</div>
					<div class="col-md-4">
						<a href="#history"><i class="fa fa-history"></i></a>
						<h4>
							<a href="#history">Completed Exercises</a>
						</h4>
						<p>Check results of completed exercises.</p>
					</div>
				</div>
			</div>
		</div>
		<!-- *****************************************************************************************************************
	 AVAILABLE EXERCISES
	 ***************************************************************************************************************** -->
		<div id="assignedExercises" class="ng-cloak" ng-controller="exercises">
			<div id="exercisesPanel" ng-show="visibility.assignedExercises"
				class="container standalone">

				<div class="row centered ng-cloak">



					<div ng-show="avExercisesList">
						<h2 class="eblue">Exercises</h2>
						
						<div class="row flexCenter">
							<div class="col-md-3 searchExercise">
								<div class="input-group" id="adv-search">
									<input ng-change="searchTags()" id="avExercisesListSearch"
										ng-model="currentSearch" autocomplete="off" type="text" class="form-control"
										placeholder="Search {{currentTechnology}} exercises" />
									<div class="input-group-btn">
										<div class="btn-group" role="group">

											<button ng-click="searchTags()" type="button"
												class="btn btn-primary">
												<span class="glyphicon glyphicon-search" aria-hidden="true"></span>
											</button>
										</div>
									</div>
								</div>
							</div>
							<div class="col-md-6">
							<img ng-class="(currentSearch == '' || currentTechnology == '') ? 'visibilityHidden' : ''" ng-src="{{getPictureForTechnology(currentTechnology)}}" class="techPictHeading" />
							</div>
							<div class="col-md-3 backToTechnologies">

								<button ng-click="backToTechnologies()"
									class="btn btn outline hideCollapsed floatRight btn-info">Back To<br/>
									Technologies</button>
							</div>
						</div>
						<div ng-repeat="e in fkExercises" class="card-deck-wrapper">
							<div class="frameworkLabel"><p class="lead marginBottom10" ng-show="currentSearch == '' && currentTechnology != ''"><strong>{{e[0].framework == 'Default' && currentTechnology || e[0].framework }}</strong></p>
							<p class="lead marginBottom10" ng-show="currentSearch != '' || currentTechnology==''"><strong>{{e[0].technology}}</strong></p>
							</div>
							<div class="card-deck frameworkBucket">
							<div ng-repeat="ex in e | orderBy:'active':true"
									class="inlineBlock ">
						<div class="center" >
  <div class="sfcard grey" ng-click="getExerciseDetails(ex.uuid)">
    <div class="additional">
      <div class="user-sfcard">
              <div class="difficulty center">difficulty</div>
        <div class="level center">
          {{ex.difficulty}}
        </div>
        <div class="duration center">duration</div>
        <div class="points center">
          {{ex.duration}}'
        </div>
        <svg width="80" height="80">
  <circle cx="40" cy="40" r="30" fill="{{getColorForScore(ex.score)}}" />
  <text x="50%" y="45%" text-anchor="middle" fill="white"
													font-family="Raleway" font-size="26px" dy=".3em">{{ex.score}}</text>
													 <text x="50%" y="70%" text-anchor="middle" fill="white"
													font-family="Raleway" font-size="9px" dy=".3em">points</text>
</svg> 
      </div>
      <div class="more-info">
        <div><p class="block-with-text marginTop0 raleway">{{ex.description}}</p></div>
       
        <div class="stats">
          <div>
            <div class="title">Awards</div>
            <i class="fa fa-trophy"></i>
          </div>
          <div>
            <div class="value maxWidthTrophyTitle multiline-ellipsis">{{ex.trophyName}}</div>
          </div>
          <div>
            <div class="title">Play Count</div>
            <i class="fa fa-gamepad"></i>
          </div>
          <div>
          
            <div class="value infinity">{{timesExercise(ex.uuid)}}</div>
          </div>
        </div>
      </div>
    </div>
    <div class="general">
    <div
											ng-show="didTakeExercise(ex.uuid) && didSolveExercise(ex.uuid)"
											class="exerciseCompleted raleway inlineBlock">Completed</div>
										<div
											ng-show="didTakeExercise(ex.uuid) && !didSolveExercise(ex.uuid)"
											class="exerciseFailed raleway inlineBlock">Not solved</div>
										<div ng-show="!didTakeExercise(ex.uuid)"
											class="exerciseNotStarted raleway inlineBlock">Not Started</div>
     <div class="sftitle"> <p class="raleway title-with-text h1title">{{ex.title}}</p></div>
           <div class="sfsubtitle"><small class="raleway title-with-text text-muted multiline-ellipsis ">{{ex.subtitle}}</small></div>
      
    </div>
  </div>
</div></div></div></div>
					

						
						
						<div class="ng-cloak marginTop110 emptyExercises"
							ng-show="emptyExercises">
							<img class="emptyExercises" src="/assets/img/emptyExercises.png" />
							<p class="raleway">There are no exercises available.</p>
						</div>

					</div>
					<div ng-show="avExercisesBrowse" class="raleway">
						<h2 class="eblue">Exercises</h2>
						<form>
							<div class="input-group" id="adv-search-wide">
								<input ng-change="searchTags()" ng-model="currentSearch"
									type="text" class="form-control" autocomplete="off"
									placeholder="Search all exercises" />
								<div class="input-group-btn">
									<div class="btn-group" role="group">

										<button ng-click="searchTags()" type="button"
											class="btn btn-primary">
											<span class="glyphicon glyphicon-search" aria-hidden="true"></span>
										</button>
									</div>
								</div>
							</div>
						</form>
						<div class="container marginTop20">
							<div class="row marginBottom20">
								<h4>Browse by:</h4>

								<div class="card-deck-wrapper">

									<div class="card-deck raleway">
										<div class="card pointer" ng-click="browseVulnerabilities()">
											<div class="card-header">
												<h4 class="lead marginTop10 marginBottom10">Vulnerability</h4>
											</div>
											<div class="card-block">
												<img src="/assets/img/vulnerability.svg" class="browsePict" />
											</div>
											<div class="card-block">
												<a ng-click="browseVulnerabilities()"
													class="btn btn-lg outline btn-primary">Browse</a>
											</div>
										</div>
										<div class="card pointer" ng-click="browseLearningPaths()">
											<div class="card-header">
												<h4 class="lead marginTop10 marginBottom10">Learning
													Path</h4>
											</div>
											<div class="card-block">
												<img src="/assets/img/learning.svg" class="browsePict" />
											</div>
											<div class="card-block">
												<a ng-click="browseLearningPaths()"
													class="btn btn-lg outline btn-primary">Browse</a>
											</div>
										</div>
									</div>
								</div>

							</div>
						</div>

					</div>

					<div ng-show="avLearningList" class="raleway">
						<h2 class="eblue">{{currentTechnology}} Learning Paths</h2>
						<form>
							<div class="col-md-3 searchExercise" >
								<div class="input-group" id="adv-search">
									<input ng-change="searchTags()" ng-model="currentSearch"
										type="text" class="form-control" autocomplete="off"
										placeholder="Search {{currentTechnology}} exercises" />
									<div class="input-group-btn">
										<div class="btn-group" role="group">

											<button ng-click="searchTags()" type="button"
												class="btn btn-primary">
												<span class="glyphicon glyphicon-search" aria-hidden="true"></span>
											</button>
										</div>
									</div>
								</div>
							</div>
							<div class="col-md-3 col-md-offset-6 backToTechnologies">

								<button ng-click="backToTechnologies()"
									class="hideCollapsed btn btn outline floatRight btn-info">Back To
									Technologies</button>
							</div>

						</form>
						<div class="card-deck-wrapper">
							<div class="card-deck" ng-repeat="e in paths">
								<div ng-repeat="ex in e" class="card buttonify raleway"
									ng-class="getExerciseClass(ex.technology)">
									<div class="paddingTop5 paddingBottom5 card-header">{{ex.technology
										== "Agnostic" && "Multi-language" || ex.technology}} Learning
										Path</div>



									<div class="row">

										<img src="/assets/img/learning.svg" class="browsePict" /><br />
										<div ng-show="isPathCompleted(ex.id)" class="taken ">Completed</div>

										<div class="gaugeRight centered">
											<img ng-src="{{getImageForDifficulty(ex.difficulty)}}">
											<p>{{ex.difficulty}}</p>
										</div>

									</div>

									<div class="card-block paddingTop5">
										<h4 class="card-title">{{ex.name}} ({{ex.difficulty}})</h4>
										<p class="card-subtitle text-muted justify">{{ex.details}}</p>
									</div>

									<div class="card-block paddingBottom10 paddingTop0">
										<p class="card-text marginTop5 marginBottom5">
											<small class="text-muted">Number of Exercises: <strong>{{ex.exercises.length}}</strong>
											</small> <small class="text-muted"> | Technology: <strong>{{ex.technology}}</strong>
											</small> <small class="text-muted"> | Difficulty: <strong>{{ex.difficulty}}</strong>
											</small>
										</p>
										<a ng-show="ex.status==0"
											ng-click="viewPathDetails(ex.technology,ex.uuid)"
											class="btn btn-primary">Browse</a> <a ng-show="ex.status==4"
											href="" class="disabled btn btn-info outline">Coming
											Soon!</a>
									</div>
								</div>
							</div>
						</div>

						<div class="ng-cloak marginTop110 emptyExercises"
							ng-show="emptyExercises">
							<img class="emptyExercises raleway"
								src="/assets/img/emptyExercises.png" />
							<p>There are no learning paths available.</p>
						</div>

					</div>

					<div ng-show="avExercisesTech" class="raleway">
						<h2 class="eblue">Exercises</h2>
						<form>
							<div class="input-group" id="adv-search-wide">
								<input ng-change="searchTags()" ng-model="currentSearch"
									type="text" class="form-control" autocomplete="off"
									placeholder="Search all exercises" />
								<div class="input-group-btn">
									<div class="btn-group" role="group">

										<button ng-click="searchTags()" type="button"
											class="btn btn-primary">
											<span class="glyphicon glyphicon-search" aria-hidden="true"></span>
										</button>
									</div>
								</div>
							</div>

							<div class="backToBrowse hideCollapsed">
								<div class="">
									<p class="marginBottom0 marginTop5">browsing by:</p>
									<h5 class="marginTop0 marginBottom0">{{getBrowseName()}}</h5>
									<img ng-src="{{getBrowseImage()}}" class="browsePictSm">
								</div>
							</div>
						</form>
						<div class="row marginTop20 marginBottom20">
							<!--  -->

							<div class="row marginBottom20">
								<!-- <h4>Browse by:</h4> -->
								<div>
								<button type="button"
											ng-class="{'active': trainingExBrowse == 'vulnerability'}"
											ng-click="browseVulnerabilities()"
											class="btn  btn-lg  btn-labeled btn-secondary ">
											<span class="btn-label"><img
												src="/assets/img/vulnerability.svg" class="browsePictSm" /></span>Vulnerability
										</button>
									<button type="button" ng-click="browseLearningPaths()"
										class="btn btn-labeled btn-lg btn-secondary marginRight5"
										ng-class="{'active': trainingExBrowse == 'paths'}">
										<span class="btn-label"><img
											src="/assets/img/learning.svg" class="browsePictSm" /></span>Learning
										Path</button>
										
								</div>
							</div>
							<h4 ng-show="!emptyExercises">Select technology:</h4>
								<div class="ng-cloak marginTop40 emptyExercises"
							ng-show="emptyExercises">
							<img class="emptyExercises" src="/assets/img/emptyExercises.png" />
							<p class="raleway">There are no exercises available.</p>
						</div>
							<div class="card-deck-wrapper">

								<div ng-repeat="row in exercisesTech" class="card-deck">
									<div href="#exercises/{{t}}"
										ng-click="showExercisesForTechnology(t)"
										class="card buttonify raleway pointer" ng-repeat="t in row"
										ng-class="getExerciseClass(t)">
										<div class="card-header"></div>
										<div class="card-block">
											<p class=" lead marginTop0 marginBottom5">{{t}}</p>
											<img ng-src="{{getPictureForTechnology(t)}}" class="techPict" />
										</div>
										<div class="card-block">
											<a ng-click="showExercisesForTechnology(t)"
												class="btn btn-primary">Browse</a>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>

					<div ng-show="avPathDetails" class="raleway">
						<h2 class="eblue">{{currentPath.name}}</h2>
						<div class="backToPaths">
							<button ng-click="browseLearningPaths()"
								class="btn btn outline btn-info hideCollapsed">Back</button>
						</div>
						<div class="row marginTop20 marginBottom20">
							<h4 class="progress-title">Details</h4>
							<p class="justify font14">{{currentPath.details}}</p>
						</div>
						<div class="row marginTop20 marginBottom20">
							<div class="col-md-4 centered">
								<h4 class="progress-title marginBottom5">Difficulty</h4>
								<img ng-src="{{getImageForDifficulty(currentPath.difficulty)}}">
								<p>
									<strong>{{currentPath.difficulty}}</strong>
								</p>
							</div>
							<div class="col-md-4 centered">
								<h4 class="progress-title">Completion</h4>
								<div class="progress green buttonify">
									<div ng-style="{width: currentPathCompletion+'%'}"
										class="progress-bar progress-bar-success progress-bar-striped active marginTop40">
										<div class="progress-value">{{currentPathCompletion}}%</div>
									</div>
								</div>
							</div>
							<div class="col-md-4 centered">
								<h4 class="progress-title">Certification</h4>
								<img class="smallCertSVG" src="/assets/img/cert.svg">
								<p class="card-text marginTop0 marginBottom0">
									<small class="text-muted">Expiration: <strong>{{currentPath.monthsExpiration}}
											months</strong></small>
									<!--<small class="text-muted"> | Renewal: <strong>{{currentPath.allowRenewal
												&& 'Permitted' || 'Not permitted'}}</strong></small><br /> <small
											class="text-muted">Refreshers: <strong>{{currentPath.refresherPercentage}}%
												within expiration date</strong></small> -->
								</p>

							</div>
						</div>
						<div class="row">
							<timeline> <timeline-event
								ng-repeat="ex in currentPath.exercises"> <timeline-badge
								when-visible="animateElementIn"
								when-not-visible="animateElementOut"
								class="{{getBackgroundForExercise(ex.uuid)}}">
							<i class="glyphicon {{getIconForExercise(ex.uuid)}}"></i> </timeline-badge> <timeline-panel
								when-visible="animateElementIn"
								when-not-visible="animateElementOut"
								class="raleway buttonifylight"> <timeline-heading>

							<div
								ng-show="didTakeExercise(ex.uuid) && didSolveExercise(ex.uuid)"
								class="taken inlineBlock">Completed</div>
							<div
								ng-show="didTakeExercise(ex.uuid) && !didSolveExercise(ex.uuid)"
								class="takenFailed inlineBlock">Not solved</div>
							<div ng-show="!didTakeExercise(ex.uuid)"
								class="notTaken inlineBlock">Not Started</div>
							<div>
								<h4 class="">{{ex.title}}</h4>
							</div>
							</timeline-heading>
							<div class="inlineBlock">
								<svg width="75" height="75">
									  <circle cx="37" cy="40" r="26"
										fill="{{getColorForScore(ex.score)}}"></circle>
									  <text x="50%" y="50%" text-anchor="middle" fill="white"
										font-family="monospace" font-size="30px" dy=".3em">{{ex.score}}</text>
									</svg>
								<p class="card-text marginTopM5">
									<small class="text-muted">up to {{ex.score}}
										points</small>
								</p>
							</div>
							<div class="inlineBlock marginLeft30">
								<img class="pathTrophySVG" src="/assets/img/trophy.svg">
								<p class="card-text">
									<small class="text-muted">{{ex.trophyName}}</small>
								</p>
							</div>
							<br />
							<p class="justify raleway font14">{{ex.description}}</p>
							<p class="card-text marginTop0 marginBottom0">
								<small class="text-muted">Duration: {{ex.duration}}
									minutes</small><small class="text-muted"> | Difficulty:
									{{ex.difficulty}} </small><br /> <small
									ng-show="didTakeExercise(ex.uuid)" class="text-muted">Play
									Count: {{timesExercise(ex.uuid)}}</small>
							</p>

							<br />
							<a ng-show="ex.status==0" ng-click="getExerciseDetails(ex.uuid)"
								href=""
								ng-class="didTakeExercise(ex.uuid) ? 'btn-success outline' : 'btn-success'"
								class="btn marginTop0">{{ !didTakeExercise(ex.uuid) && 'Get
								Started' || 'Run again'}}</a> <a ng-show="ex.status>0" href=""
								class="disabled marginTop0 btn btn-info">{{getExerciseStatusString(ex.status)}}</a>
							</timeline-panel> </timeline-event> </timeline>
						</div>
					</div>
				</div>


			</div>





			<div id="currentExercisePanel" ng-show="visibility.exerciseDetails"
				class="container standalone ng-cloak">
				<h2 class="eblu inlineBlock">Exercise</h2>
				<div class="inlineBlock floatRight">

					<button ng-click="historyBack()"
						class="btn btn outline exerciseUserBack btn-info">Back</button>
				</div>

				<div class="card paddingBottom10">
					<div class="card-header">{{exerciseDetails.technology}}</div>
					<div class="container">
						<div class="row">
							<div class="col-md-8">
								<h3 class="card-title marginTop10">{{exerciseDetails.title}}</h3>
								<h6 class="ellipsis card-subtitle text-muted">{{exerciseDetails.subtitle}}</h6>
								<div class="">
									<p class="card-text exerciseCardText font14">{{exerciseDetails.description}}</p>
									<div class="marginTop30" ng-show="exerciseKbs.length>0">
										 <div ng-repeat="kb in exerciseKbs" class="marginBottom10">
										 <h5><i
													class="fa fa-graduation-cap marginRight5"></i><a href=""
													ng-click="openVulnKB(kb,exerciseDetails.technology)">Click here</a> to know more
													about this vulnerability.</h5>
											
										</div>

									</div>

									<div id="exerciseInfoMD"></div>
									<p class="card-text">
										<span class="text-muted">Duration:
											{{exerciseDetails.duration}} minutes</span><span class="text-muted">
											| Difficulty: {{exerciseDetails.difficulty}} </span><span
											class="text-muted"> | Author:
											{{exerciseDetails.author}} </span>
									</p>

								</div>
							</div>
							<div class="col-md-4">
								<div class="col-md-6 centered hideCollapsed">
									<h4 class="marginBottom0">Score</h4>
									<svg width="90" height="90">
  <circle cx="45" cy="45" r="35"
											fill="{{getColorForScore(exerciseDetails.score)}}" />
  <text x="50%" y="50%" text-anchor="middle" fill="white"
											font-family="monospace" font-size="45px" dy=".3em">{{exerciseDetails.score}}</text>
</svg>
									<p class="card-text marginTopM5 ellipsis">
										<small class="text-muted ">gain up to
											{{exerciseDetails.score}} points</small>
									</p>
								</div>
								<div class="col-md-6 centered hideCollapsed">
									<h4>Trophy</h4>
									<img class="trophySVG" src="/assets/img/trophy.svg">
									<p class="card-text ellipsis">
										<small class="text-muted">{{exerciseDetails.trophyName}}</small>
									</p>
								</div>
								<div ng-show="!exerciseStarted"
									class="col-md-10 col-md-offset-1 centered marginTop20"><!--  && !isEdge -->
									<button
										ng-show="!noRegionsAvailable && !exerciseRestartCrashed && !(exerciseDetails.technology == 'Android' && isEdge) && !(exerciseDetails.technology == 'Android' && isIE)"
										ng-click="startExerciseModal(exerciseDetails.id,exerciseDetails.uuid)"
										class="btn btn-block btn-success marginTop10 btn-xl">
										Start <br>
									</button><!--  && !isEdge -->
									<button
										ng-show="!noRegionsAvailable && exerciseRestartCrashed"
										ng-click="startExerciseModal(exerciseDetails.id,exerciseDetails.uuid)"
										class="btn btn-block btn-success marginTop10 btn-xl">
										Restart <br>
									</button>
									<button ng-show="noRegionsAvailable || (exerciseDetails.technology == 'Android' && isEdge) || (exerciseDetails.technology == 'Android' && isIE)"
										class="disabled btn-block btn btn-info marginTop10 btn-xl">
										Unavailable <br>
									</button>
									<div class="marginTop5" ng-show="(exerciseDetails.technology == 'Android' && isEdge)">Unfortunately
										Android exercises are not supported on Microsoft Edge Legacy. To run Android exercises
										<a href="https://support.microsoft.com/en-gb/help/4501095/download-the-new-microsoft-edge-based-on-chromium" target="_blank">update</a> your Microsoft Edge browser or use Chrome, Firefox, or Safari.</div>
									<div class="marginTop5" ng-show="(exerciseDetails.technology == 'Android' && isIE)">Unfortunately
										Android exercises are not supported on Internet Explorer. To run Android exercises please use Microsoft Edge, Chrome, Firefox, or Safari.</div>
								</div>
							</div>
						</div>
						<div class="row">

							<div ng-show="exerciseStarted" class="marginTop20">
								<div class="well wellExerciseStart">
									<div id="countdown" ng-show="!ready">
										<p class="lead">We're preparing your exercise, your SecureFlag
											environment will be ready in:</p>
										<span class="badge" id="cdown">{{countdown}}</span>
									</div>
									<div id="environmentReady" ng-show="ready">
										<p class="lead">Your SecureFlag environment is ready!</p>
										<button id="launchEnvironment" ng-click="launchEnvironment()"
											class="btn btn-success btn-xl">Launch</button>
										<button id="stopExerciseButton" ng-show="alreadyLaunched"
											ng-click="stopExercise(exInstanceId)"
											class="marginLeft50 btn btn-xl btn-primary">Stop</button>
										<a class="displayNone" id="synEl" ng-href="{{synId}}"></a>
									</div>
									<div id="preload"></div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="row"></div>

			</div>

			<div id="kbModal" class="modal fade" tabindex="-1" role="dialog">
				<div class="modal-dialog modal-lg" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Vulnerability Info</h4>
						</div>
						<div class="modal-body paddingTop0">
							<div id="kbMD"></div>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
						</div>
					</div>
				</div>
			</div>
			<div id="startExerciseModal" class="modal fade" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title" ng-show="!exerciseRestartCrashed">Start
								Exercise</h4>
							<h4 class="modal-title" ng-show="exerciseRestartCrashed">Restart
								Exercise</h4>

						</div>
						<div class="modal-body modalStartExercise">
							<p class="lead" ng-show="exerciseIsInChallenge && !exerciseAlreadySolved">
								<strong>This exercise is part of a tournament.</strong> 
							</p>
							
							<p class="lead">The recommended duration of this exercise is
								{{exerciseDetails.duration}} minutes.</p>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
							<button type="button" ng-show="exerciseRestartCrashed"
								ng-click="startInstance(exerciseDetails.uuid)"
								class="btn btn-primary">Restart Exercise</button>
							<button type="button" ng-show="!exerciseRestartCrashed"
								ng-click="startInstance(exerciseDetails.uuid)"
								class="btn btn-primary">Start Exercise</button>
						</div>
					</div>
				</div>
			</div>
			<div id="attemptAgainChallengeExerciseModal" class="modal fade" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Attempt
								Exercise Again</h4>

						</div>
						<div class="modal-body modalStartExercise">
							<p class="lead">
								<strong>This exercise is part of a tournament.</strong></p>
								<p class="lead">You have already attempted this exercise. To play it again, the results of your previous attempt will be <strong>deleted</strong>.
							</p>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
							<button type="button"
								ng-click="retryChallengeExercise()"
								class="btn btn-danger">Confirm</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<!-- CHALLENGES ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="challenges"
			ng-show="visibility.challenges" ng-controller="challenges">
			<div class="container" ng-show="showChallengesList">
				<div class="row ">
					<h2 class="eblue centered">Tournaments</h2>
				</div>
				<div class="row centered" ng-show="masterChallengesList.length > 0">
					<div ng-show="masterChallengesList.length>0 && areThereCompleted()"
						class="centered toggleHideCancelled hideCollapsed">
						<toggle onstyle="btn-primary" ng-model="showCompleted"
							on="Hide Completed" off="Show Completed"></toggle>
					</div>
					<div class="right refreshTog hideCollapsed">
					<i ng-class="{'opacity02' : refreshing }" title="Refresh"
						ng-click="updateActiveTournaments()"
						class="fa fa-2x fa-history pointer"></i>
					<p>
						<small>Refreshed at
							{{getDateInCurrentTimezone(lastUpdated,'HH:mm (Z)')}}</small>
					</p>
				</div>
					<div class="card-deck-wrapper">
						<div class="card-deck buttonifylight challengeDeck marginTop15"
							ng-repeat="c in filteredChallengesList | orderBy:'-status' ">
							<div class="container marginTop15">
								<div class="row vertical-align">
									<div class="col-md-2">
										<div class="row">
											<img class="challengeImgPanel"
												src="/assets/img/challenge.svg">

											<h3 class="marginTop0">{{c.name}}</h3>
										</div>
									</div>
									<div class="block col-md-8 ">
										<div class="row hideCollapsed">
											<div class="col-md-3 ">
												<p class="statsText">Exercises</p>
												<span class="badge challengeBadge statsBadgeColor5">{{c.scopeExercises.length}}</span>
											</div>
											<div class="col-md-3 ">
												<p class="statsText">Users</p>
												<span class="badge challengeBadge statsBadgeColor5">{{c.users.length}}</span>

											</div>
											<div class="col-md-3 ">
												<p class="statsText">Completion</p>
												<span class="badge challengeBadge statsBadgeColor5">{{c.completion
													| number: 1}}%</span>
											</div>
											<div class="col-md-3 tournamentStatus">
												<p class="statsText">Tournament Status</p>
												<span ng-class="getTournamentStatusClass(c.status)"
													class="badge font14">{{getChallengeStatusString(c.status)}}</span>

											</div>

										</div>

										<div class="row marginBottom10 marginTop10 hideCollapsed">
											<div class="col-md-3 ">
												<p class="statsText">Start Date</p>
												<span class="badge font14 statsBadgeColor1">{{getDateInCurrentTimezone(c.startDate,'MMM
													D YYYY HH:mm')}}</span>
											</div>
											<div class="col-md-3 ">
												<p class="statsText">End Date</p>
												<span class="badge font14 statsBadgeColor1">{{getDateInCurrentTimezone(c.endDate,'MMM
													D YYYY HH:mm')}}</span>
											</div>
											<div class="col-md-3 ">
												<p class="statsText">Last Activity</p>
												<span class="badge font14 statsBadgeColor1">{{getDateInCurrentTimezone(c.lastActivity,'MMM
													D YYYY HH:mm')}}</span>
											</div>
											<div class="col-md-3 "></div>

										</div>


									</div>
									<div class="vertical-align col-md-2">
										<button ng-click="getChallengeDetailsButton(c.id)"
											class="btn btn-primary outline btn-lg">
											View <br /> Table & Exercises
										</button>
									</div>
								</div>


							</div>
						</div>
					</div>
				</div>
				<div class="centered marginTop20"
					ng-show="masterChallengesList.length==null || noActiveChallenges ">
					<img class="emptyExercises" src="/assets/img/emptyExercises.png" />
					<p>There are currently no active tournaments for your Organization.</p>
				</div>
			</div>
			<div ng-show="showChallengeDetails">

				<div class="container centered">
					<div class="row">
						<a ng-click="backToList()"
							class="backToAbsolute outline btn btn-info btn-lg">Back</a>

						<h2 class="eblue">{{challengeDetails.name}}</h2>
						<div class="center marginTop20">
							<p class="statsText">Tournament Status</p>
							<span
								ng-class="getTournamentStatusClass(challengeDetails.status)"
								class="badge font14 buttonify">{{getChallengeStatusString(challengeDetails.status)}}</span>
						</div>
					</div>
					<div class="row marginTop10">
						<div class="col-md-5">

							<div class="row  left">
								<h4 class="center">Tournament Details</h4>
								<img class="challengeImg" src="/assets/img/challenge.svg">

								<p class="justify margin30 font14">{{challengeDetails.details}}</p>

							</div>
						</div>
						<div class="col-md-7">
							<div class="row">
								<h4 class="">Tournament Info</h4>

								<div class="row">
									<div class="col-md-4 ">
										<p class="statsText">Start Date</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{getDateInCurrentTimezone(challengeDetails.startDate,'MMM
											D YYYY HH:mm')}}</span>
									</div>
									<div class="col-md-4">
										<p class="statsText">End Date</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{getDateInCurrentTimezone(challengeDetails.endDate,'MMM
											D YYYY HH:mm')}}</span>
									</div>
									<div class="col-md-4">
										<p class="statsText">Last Activity</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{getDateInCurrentTimezone(challengeDetails.lastActivity,'MMM
											D YYYY HH:mm')}}</span>
									</div>

								</div>
								<div class="row marginTop5">

									<div class="col-md-4 ">
										<p class="statsText">Users</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{challengeDetails.users.length}}</span>
									</div>

									<div class="col-md-4 ">
										<p class="statsText">Exercises</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{challengeDetails.scopeExercises.length}}</span>
									</div>

									<div class="col-md-4 ">
										<p class="statsText">Running Exercises</p>
										<span class="badge buttonify font14 statsBadgeColor3">{{challengeDetails.challengeRunningExercises}}</span>
									</div>


								</div>

								<div class="row marginTop5">
									<div class="col-md-4 ">
										<p class="statsText">Tournament Completion</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{challengeDetails.completion
											| number: 1}}%</span>
									</div>
									<div class="col-md-4">
										<p class="statsText">Tournament Remediation</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{challengeDetails.remediation
											| number: 1}}%</span>
									</div>
									<div class="col-md-4 ">
										<p class="statsText">Tournament Run Exercises</p>
										<span class="badge buttonify font14 statsBadgeColor1">{{challengeDetails.challengeRunExercises}}</span>
									</div>


								</div>
								<div class="row marginTop5">
									<div class="col-md-4 ">
										<p class="statsText">
											<strong>Your Completion</strong>
										</p>
										<span class="badge buttonify font14 statsBadgeColor2">{{
											challengeDetails.userCompletion | number: 1}}%</span>
									</div>
									<div class="col-md-4">
										<p class="statsText">
											<strong>Your Remediation</strong>
										</p>
										<span class="badge buttonify font14 statsBadgeColor2">{{challengeDetails.userRemediation
											| number: 1}}%</span>
									</div>
									<div class="col-md-4">
										<p class="statsText">
											<strong>Your Run Exercises</strong>
										</p>
										<span class="badge buttonify font14 statsBadgeColor2">{{challengeDetails.userRunExercises}}</span>
									</div>


								</div>
							</div>
						</div>
					</div>
				</div>


				<div class="container marginTop20">
					<div class="row">

						<div class="marginBottom20 center col-md-4 col-md-offset-4"
							ng-show="challengeDetails.winners.length > 0">
							<img class="racingFlagsTournament center"
								src="/assets/img/racing-flags.svg">
							<h4 class="center">Tournament Winners</h4>
							<div class="col-md-10 col-md-offset-1 left">
								<table class="table">
									<thead>
										<tr>
											<th>User</th>
											<th class="right">Score</th>
										</tr>
									</thead>
									<tbody>
										<tr
											ng-repeat="winner in challengeDetails.winners  | orderBy: '-score'">
											<td>{{getUsernameFromId(winner.idUser)}}</td>
											<td class="right">{{winner.score}}</td>
										</tr>
									</tbody>
								</table>
							</div>
						</div>

					</div>
					<div class="row marginTop20">


						<div class="col-md-8 col-md-offset-2 marginTop20">
							<div class="row center">

								<h4 class="center">Tournament Table</h4>
								<div class="tableFilter hideCollapsed">
									<p class="inlineBlock">Search:</p>
									<input placeholder="Type to filter..." autocomplete="off"
										ng-change="updateTableFilteredList()" ng-model="tableQuery"
										class="queryInput">
								</div>
								<table class="table table-hover left tournamentTable font12" at-table
									at-list="challengeDetailsTableFilteredList" at-paginated
									at-config="challengeUserTableConfig">
									<thead>

									</thead>
									<tbody>
										<tr ng-class="highlightIfTableUser(item.user)">
											<td at-title="#">{{(challengeUserTableConfig.currentPage * 10)+($index+1)}}</td>
											<td at-attribute="user" at-title="User">{{item.user}}</td>
											<td class="right" at-initial-sorting="desc"
												at-attribute="challengeScore" at-title="Score">{{item.challengeScore}}</td>
											<td class="right" at-attribute="challengeRunExercises"
												at-title="Run Exercises">{{(item.challengeRunExercises)}}</td>
											<!-- <td at-attribute="team.name" at-title="Team">{{item.team.name}}</td> -->
											<td at-attribute="country.name"
												at-title="Country">{{item.country.name}}</td>


										</tr>
									</tbody>
								</table>
								<at-pagination at-list="challengeDetailsTableFilteredList"
									at-config="challengeUserTableConfig"></at-pagination>
								<div>
									<p>
										<small>Refreshed at
											{{getDateInCurrentTimezone(challengeDetails.lastRefreshed,'HH:mm
											(Z) on MMM D YYYY')}}</small> <i
											ng-class="{'opacity02' : refreshing }" title="Refresh"
											ng-click="triggerChallengeUpdate(challengeDetails.id)"
											class="fa fa-history pointer"></i>
									</p>
								</div>

							</div>
						</div>
					</div>
				</div>
				<div class="container marginTop30">

					<div class="row centered">
						<img src="/assets/img/exercise.svg"
							class="inlineBlock exerciseTournamentSvg">
						<h4 class="center inlineBlock">Tournament Exercises</h4>
						
						
						<div ng-repeat="e in exercises" class="card-deck-wrapper">
							<div class="card-deck">
								<div ng-repeat="ex in e | orderBy:'active':true"
									class="card buttonify"
									ng-class="getExerciseClass(ex.technology)">
									<div class="paddingTop5 paddingBottom5 card-header">{{ex.technology}}</div>
									<div class="card-block paddingTop5 ng-cloak">
										<div
											ng-show="didTakeChallengeExercise(ex.uuid) && !didSolveChallengeExercise(ex.uuid)"
											class="takenFailed inlineBlock">Not solved</div>

										<div
											ng-show="didTakeChallengeExercise(ex.uuid) && didSolveChallengeExercise(ex.uuid)"
											class="taken">Completed</div>
										<div ng-show="!didTakeChallengeExercise(ex.uuid)"
											class="notTaken">Not Completed</div>
										<h4 class="card-title">{{ex.title}}</h4>
										<h6 class="ellipsis card-subtitle text-muted">{{ex.subtitle}}</h6>
									</div>
									<div class="row center marginTop0 marginBottom0">
										<h4 class="marginTop0 marginBottom0">Score</h4>
										<svg width="120" height="120">
  <circle cx="60" cy="60" r="50" fill="{{getColorForScore(ex.score)}}" />
  <text x="50%" y="45%" text-anchor="middle" fill="white"
												font-family="monospace" font-size="55px" dy=".3em">{{ex.score}}</text>
  <text x="50%" y="70%" text-anchor="middle" fill="white"
												font-family="monospace" font-size="12px" dy=".3em">points</text>

</svg>

									</div>
									<div
										class="card-block paddingBottom10 paddingTop0 marginTop0 marginBottom0">
										<p class="card-text marginTop0">
											<small class="text-muted">Duration: {{ex.duration}}
												minutes</small><small class="text-muted"> | Difficulty:
												{{ex.difficulty}} </small>
										</p>
										
										<div class="ng-cloak">
											<button ng-show="challengeDetails.status == 'IN_PROGRESS' && didTakeChallengeExercise(ex.uuid) && didSolveChallengeExercise(ex.uuid)"
											class="btn btn-primary disabled">Completed</button>
										<button
											ng-show="challengeDetails.status == 'IN_PROGRESS' && didTakeChallengeExercise(ex.uuid) && !didSolveChallengeExercise(ex.uuid)"
											ng-click="retryChallengeExerciseModal(getUserExerciseIdForUuid(ex.uuid),ex.uuid)"
											class="btn btn-warning">Try Again?</button>
										<a
											ng-show="(ex.status==0 || ex.status==4) && challengeDetails.status == 'IN_PROGRESS' && !didTakeChallengeExercise(ex.uuid)"
											ng-click="getExerciseDetails(ex.uuid)" href=""
											class="btn btn-primary">Get Started</a> <a
											ng-show="ex.status>0 && ex.status != 4" href=""
											class="btn btn-info disabled">{{getExerciseStatusString(ex.status)}}</a>
										<a ng-show="challengeDetails.status == 'NOT_STARTED'"
											ng-click="getExerciseDetails(ex.uuid)" href=""
											class="btn disabled btn-primary">Tournament Not Started</a>
									</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="container marginTop30">
					<div class="row">
						<div class="center">
							<img src="/assets/img/checklist.svg"
								class="inlineBlock center exerciseTournamentSvg">
							<h4 class="center inlineBlock margimBottom0">Tournament
								Results</h4>
						</div>

						<div>
							<div class="left hideCollapsed">
								<p class="inlineBlock">Search:</p>
								<input placeholder="Type to filter..." autocomplete="off"
									ng-change="updateTableFilteredList()" ng-model="tableQuery"
									class="queryInput">
							</div>
							<div class="scrollx">
							<table class="table table-hover ng-cloak font12" id="challengeResultsHeader">
								<thead>
									<tr>
										<th class="width185 allCaps"><strong>User</strong></th>
										<th class="width185 centered"
											ng-repeat="t in challengeDetails.theads | orderBy: 'id'">{{t.name}}</th>
									</tr>
								</thead>
							</table>
							<table class="table table-hover ng-cloak font12" at-table at-paginated
								at-list="challengeDetailsTableFilteredList"
								at-config="challengeUserTableConfig" id="challengeResults">
								<thead>

								</thead>
								<tbody>

									<tr ng-class="highlightIfUser(item.user)">
										<td class="width185" at-attribute="{{item.user}}" at-title="">{{item.user}}</td>

										<td class="centered width185" at-attribute="{{f.name}}"
											at-title="{{f.name}}"
											ng-class="getClassForChallengeResult(item.user,f.name)"
											ng-repeat="f in challengeDetails.theads | orderBy: 'id'">
											<span
											ng-show="!isUser(item.user) || getChallengeResultFor(item.user,f.name) == 'Not Started' || getExerciseStatusForFlag(item.user,f.name) == 'RUNNING'">{{getChallengeResultFor(item.user,f.name)}}</span><a
											ng-show="isUser(item.user) && getChallengeResultFor(item.user,f.name) != 'Not Started' && getExerciseStatusForFlag(item.user,f.name) != 'RUNNING'"
											href="#/history/details/{{getExerciseIdForFlag(item.user,f.name)}}">{{getChallengeResultFor(item.user,f.name)}}</a>
											<span ng-show="isPlacedInChallenge(item.user,f.name)"
											ng-class="getClassPlacementInChallenge(item.user,f.name)"
											class="badge">{{getPlacementInChallenge(item.user,f.name)}}</span>
										</td>
									</tr>
								</tbody>

							</table>
							</div>
							<div class="center hideCollapsed">
								<at-pagination at-list="challengeDetailsTableFilteredList"
									at-config="challengeUserTableConfig"></at-pagination>
							</div>
						</div>

						<p class="center">
							<small>Refreshed at
								{{getDateInCurrentTimezone(challengeDetails.lastRefreshed,'HH:mm
								(Z) on MMM D YYYY')}}</small> <i ng-class="{'opacity02' : refreshing }"
								title="Refresh"
								ng-click="triggerChallengeUpdate(challengeDetails.id)"
								class="fa fa-history pointer"></i>
						</p>
						<div>
							<div class="col-md-6 col-md-offset-3 center marginTop20"
								ng="challengeDetails.firstInFlag > 0">
								<img src="/assets/img/score.png"
									class="inlineBlock exerciseTournamentSvg">
								<h4 class="center inlineBlock">Bonus Points</h4>

								<p class="marginTop10">
									<span class="goldPlacement badge">1st</span> receives <strong>{{challengeDetails.firstInFlag}}%</strong>
									bonus points.
								</p>
								<p>
									<span class="silverPlacement badge">2nd</span> receives <strong>{{challengeDetails.secondInFlag}}%</strong>
									bonus points.
								</p>
								<p>
									<span class="bronzePlacement badge">3rd</span> receives <strong>{{challengeDetails.thirdInFlag}}%</strong>
									bonus points.
								</p>

							</div>
						</div>
					</div>
				</div>
			</div>
			<div id="retryChallengeExerciseModal" class="modal fade" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title" ng-show="!exerciseRestartCrashed">Attempt
								Exercise Again</h4>

						</div>
						<div class="modal-body modalStartExercise">
							<p class="lead">
								<strong>This exercise is part of a tournament.</strong></p>
								<p class="lead">You have already attempted this exercise. To play it again, the results of your previous attempt will be <strong>deleted</strong>.
							</p>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
							<button type="button"
								ng-click="retryChallengeExercise()"
								class="btn btn-danger">Confirm</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<!-- *****************************************************************************************************************
	 RUNNING EXERCISES
	 ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="running"
			ng-show="visibility.runningExercises" ng-controller="running">
			<div class="container">
				<div class="right refreshTog hideCollapsed">
					<i ng-class="{'opacity02' : refreshing }" title="Refresh"
						ng-click="updateRunningExercises()"
						class="fa fa-2x fa-history pointer"></i>
					<p>
						<small>Refreshed at
							{{getDateInCurrentTimezone(lastUpdated,'HH:mm (Z)')}}</small>
					</p>
				</div>
				<div class="row centered"
					ng-show="runningInstances.length > 0 || (runningInstances.length == 0 && crashedInstances.length == 0 && userReservations.length == 0)">
					<h2 class="eblue">Running Exercises</h2>

					<span class="badge scoreBadge"
						ng-show="runningInstances.length > 0">{{runningInstances.length}}</span>
					<div class="card-deck-wrapper marginTop20">
						<div class="card-deck">
							<div ng-repeat="ex in runningInstances" class="card"
								ng-class="getExerciseClass(ex.technology)">
								<div class="card-header">{{ex.technology}}</div>
								<div class="card-block">
									<h4 class="card-title">{{ex.title}}</h4>
									<h5 class="card-subtitle">{{ex.exercise.subtitle}}</h5>
									<p class="card-text">
										Start time: <small class="text-muted">{{getDateInCurrentTimezone(ex.startTime,'MMM
											D YYYY HH:mm')}}</small> | End time: <small class="text-muted">{{getDateInCurrentTimezone(ex.endTime,'MMM
											D YYYY HH:mm')}}</small>
									</p>
									<a ng-click="resumeExercise(ex.id,ex.exercise.uuid)" href=""
										class="btn btn-sm btn-success">Resume Exercise</a> <a
										ng-click="stopExercise(ex.id)" href=""
										class="btn btn-sm btn-primary">Mark Completed</a>
								</div>
							</div>
						</div>
					</div>
					<div ng-show="runningInstances.length == 0">
						<img class="emptyExercises" src="/assets/img/emptyExercises.png" />
						<p>There are no running exercises.</p>
						<p>
							Browse available <a href="#exercises"> exercises</a> or <a
								href="#tournaments">tournaments</a>.
						</p>
					</div>
				</div>
				<div class="row centered" ng-show="crashedInstances.length > 0">
					<h2 class="eblue">Unexpectedly Stopped Exercises</h2>
					<span class="badge scoreBadge">{{crashedInstances.length}}</span>


					<div class="card-deck-wrapper marginTop20">
						<div class="card-deck">
							<div ng-repeat="r in crashedInstances" class="card"
								ng-class="getExerciseClass(r.exercise.technology)">
								<div class="card-header">{{r.exercise.technology}}</div>
								<div class="card-block">
									<h4 class="card-title">{{r.exercise.title}}</h4>
									<h5 class="card-subtitle">
										<small>{{r.exercise.subtitle}}</small>
									</h5>
									<p class="card-text">
										Previous score: <strong>{{r.score.result == -1 && "0"
											|| r.score.result}}/{{r.score.total}}</strong>
									</p>
									<p>
										<small>This exercise has stopped unexpectedly.<br>You
											can either accept the score, restart the exercise retaining
											your previous score, or cancel the exercise.
										</small>
									</p>
									<a ng-click="acceptCrashed(r.id)" href=""
										class=" outline btn btn-primary">Accept<br />Result
									</a> <a ng-click="restartCrashed(r.id,r.exercise.uuid)" href=""
										class=" outline marginLeft10 btn btn-success">Restart<br />Exercise
									</a> <a ng-click="cancelCrashed(r.id)" href=""
										class=" outline marginLeft10 btn btn-warning">Cancel<br />Exercise
									</a>
								</div>
							</div>
						</div>
					</div>

				</div>
				<div class="row centered" ng-show="userReservations.length>0">
					<h2 class="eblue">Exercise Reservations</h2>
					<span class="badge scoreBadge">{{userReservations.length}}</span>
					<div class="card-deck-wrapper marginTop20">
						<div class="card-deck">
							<div ng-repeat="r in userReservations" class="card"
								ng-class="getExerciseClass(r.exercise.technology)">
								<div class="card-header">{{r.exercise.technology}}</div>
								<div class="card-block">
									<h4 class="card-title">{{r.exercise.title}}</h4>
									<h5 class="card-subtitle">{{r.exercise.subtitle}}</h5>
									<img src="/assets/img/bars.svg" class="loadingBars"><br>
									<a disabled="disabled" href=""
										class="marginTop10 btn btn-sm btn-success">Please Wait...</a>
								</div>
							</div>
						</div>
					</div>
					<p class="lead">
						<small>Please wait while we prepare your SecureFlag environment.</small>
					</p>

				</div>
			</div>
		</div>
		<!-- *****************************************************************************************************************
	LEADERBOARD
	 ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="leaderboard"
			ng-show="visibility.leaderboard" ng-controller="leaderboard">
			<div class="container">
				<div class="row centered">
					<h2 class="eblue">Team Leaderboard</h2>
					<div class="right refreshTog hideCollapsed">
						<i ng-class="{'opacity02' : refreshing }" title="Refresh"
							ng-click="updateTeamStats()" class="fa fa-2x fa-history pointer"></i>
						<p>
							<small>Refreshed at
								{{getDateInCurrentTimezone(lastUpdated,'HH:mm (Z)')}}</small>
						</p>
					</div>
					<div ng-show="user.team.name">
						<span
							class="teamBadge b-primary marginTop20 badge buttonify inlineBlock">{{user.team.name}}</span>
						<table at-table at-paginated at-list="leaderboardData"
							at-config="leaderboardtableconfig"
							class="table marginTop20 table-striped leaderboardTable">

							<thead>
							</thead>

							<tbody>
								<tr>
									<td at-attribute="user" at-sortable at-title="User">{{item.user}}</td>
									<td at-attribute="country.name" at-sortable at-title="Country">{{item.country.name}}</td>
									<td at-initial-sorting="desc" at-attribute="score" at-sortable
										class="right" at-title="Points">{{item.score}}</td>
									<td at-attribute="exercisesRun" at-sortable class="right"
										at-title="Run Exercises">{{item.exercisesRun}}</td>
								</tr>
							</tbody>
						</table>
						<at-pagination at-list="leaderboardData"
							at-config="leaderboardtableconfig"></at-pagination>

						<div class="row" ng-show="remediationRatePerIssue.length>0">
							<h2 class="eblue centered">Team Stats</h2>
							<h4 class="centered marginTop30 marginBottom20">Remediation
								Rate by Vulnerability Category</h4>
							<canvas id="remediatedPerIssue" class="chart chart-radar"
								chart-data="remediatedPerCategoryPercentage.data"
								chart-series="remediatedPerCategoryPercentage.series"
								chart-options="remediatedPerCategoryPercentage.options"
								chart-labels="remediatedPerCategoryPercentage.labels">
								</canvas>
						</div>
						<div class="row" ng-show="remediationRatePerCategory.length>0">
							<h4 class="centered marginTop30 marginBottom20">Average/Total
								Duration by Vulnerability Category</h4>
							<div class="col-md-10 col-md-offset-1">
								<canvas id="remediatedPerCategoryTime" class="chart chart-bar"
									chart-data="remediatedPerCategoryTime.data"
									chart-series="remediatedPerCategoryTime.series"
									chart-options="remediatedPerCategoryTime.options"
									chart-labels="remediatedPerCategoryTime.labels"
									chart-dataset-override="remediatedPerCategoryTime.datasetOverride">
										</canvas>
							</div>
						</div>
						<div class="row inlineBlock hideCollapsed"
							ng-show="remediationRatePerIssue.length>0">
							<h4 class="centered marginTop30 marginBottom20">Individual
								Issue Remediation Breakdown</h4>
							<div class="col-md-3 marginBottom10 "
								ng-repeat="c in remediationRatePerIssue">
								<canvas width="203%" height="203%" class="chart chart-doughnut"
									chart-data="c.data" chart-options="c.options"
									chart-labels="c.labels">
									</canvas>
							</div>
						</div>
					</div>
					<div ng-show="!user.team.name">
						<img class="emptyTeam" src="/assets/img/emptyTeam.png" />
						<p>You are not part of a team.</p>
					</div>
				</div>
			</div>
		</div>
		<!-- *****************************************************************************************************************
    HISTORY
	 ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="history"
			ng-show="visibility.history" ng-controller="history">
			<div class="container">
				<div class="row ">
					<h2 class="eblue centered">Completed Exercises</h2>
					<div ng-show="masterCompletedReviews.length>0">
						<div class="tableFilter hideCollapsed">
							<p class="lead inlineBlock">Filter:</p>
							<input placeholder="Type to filter..." autocomplete="off"
								ng-change="updateFilteredList()" ng-model="query"
								class="queryInput">
						</div>
						<div class="right refreshTog hideCollapsed">
							<i ng-class="{'opacity02' : refreshing }" title="Refresh"
								ng-click="getUserHistory()" class="fa fa-2x fa-history pointer"></i>
							<p>
								<small>Refreshed at
									{{getDateInCurrentTimezone(lastUpdated,'HH:mm (Z)')}}</small>
							</p>
						</div>
						<table at-table at-paginated at-list="filteredCompletedList"
							at-config="tableconfig"
							class="table table-hover completedUserTable font12">
							<thead>
								<tr>
								</tr>
							</thead>
							<tbody>
								<tr ng-class="{active: $index===selectedResultRow}">
									<td at-initial-sorting="desc" width="55" at-title=" # "
										at-sortable at-implicit at-attribute="id"></td>
									<td at-title="Exercise" at-sortable at-implicit
										at-attribute="title"></td>
									<td at-title="Tech." class="left" at-sortable at-implicit
										at-attribute="technology"></td>
									<td at-attribute="startTime" at-sortable
										at-title="Date / Duration">{{getDateInCurrentTimezone(item.startTime,
										'MMM D YYYY
										HH:mm')}}&nbsp;({{getDurationInterval(item.startTime,item.endTime,item.duration)}})</td>
									<td at-attribute="score.result" at-title="Score" class="right"
										ng-class="getResultsScoreClass(item.score.result,item.score.total, item.status)">
										{{ getResultsScore(item.score) }}/{{item.score.total}}</td>
									<td class="center" at-title="Tournament" at-sortable
										at-attribute="challengeId"><span
										ng-show="item.type != 'CHALLENGE'">No</span><a
										ng-show="item.type == 'CHALLENGE'"
										href="#/tournaments/details/{{item.challengeId}}">Yes</a></td>

									<td class="center" at-title="Status" width="85" at-sortable
										at-attribute="status">{{getExerciseStatusString(item.status)}}</td>
									<td>
										<button ng-click="showExerciseResult(item.id,$index)"
											class="btn btn-sm btn-primary outline">View Results</button>
									</td>
								</tr>
							</tbody>
						</table>
						<at-pagination at-list="filteredCompletedList"
							at-config="tableconfig"></at-pagination>

					</div>
					<div class="centered" ng-show="masterCompletedReviews.length<=0">
						<img class="emptyHistory" src="/assets/img/emptyHistory.png" />
						<p>There are no results.</p>
						<p>
							Complete an <a href="#exercises">exercise</a> to check your
							results.
						</p>
					</div>
				</div>
				<div ng-show="showResults" class="row ">
					<div id="showCompletedResults" class="row marginBottom20">
						<div class="row">
							<div class="col-md-12">
								<h3 class="eblue centered">#{{userHistoryDetails.id}} -
									{{userHistoryDetails.exercise.title}}
									({{userHistoryDetails.exercise.technology}})</h3>
								<h3 class="centered">Exercise Flags</h3>
								<div ng-repeat="flag in userHistoryDetails.exercise.flags"
									class="panel panel-default">
									<div class="panel-heading">
										<h4 class="panel-title">
											<a data-toggle="collapse" data-target="#{{flag.id}}" href="">
												{{flag.title}} </a><small>Click to expand.</small>
										</h4>
									</div>
									<div id="{{flag.id}}" class="panel-collapse collapse">
										<div class="panel-body">
											<table>
												<thead class="theadSpace">
													<tr>

														<th class="verticalAlignTop">Instructions</th>
														<th class="center verticalAlignTop">Type</th>
														<th class="center verticalAlignTop">Score</th>
														<th class="center verticalAlignTop">Hint</th>
														<th class="center verticalAlignTop">Auto Checker</th>
													</tr>
												</thead>
												<tbody>
													<tr ng-repeat="f in flag.flagList" class="spaceUnder">
														<td class="w70 verticalAlignTop"><div
																id="f{{f.id}}-md" ng-init="triggerFlagsMarkdown(f)"></div></td>
														<td class="center verticalAlignTop">{{f.type}}</td>

														<td class="center verticalAlignTop">{{f.maxScore ||
															'Optional'}}</td>
														<td class="center verticalAlignTop">{{f.hintAvailable
															&& 'Yes' || 'No'}}</td>
														<td class="center verticalAlignTop">{{f.selfCheck.name
															&& 'Yes' || 'No'}}</td>
													</tr>
												</tbody>
											</table>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div ng-show="userHistoryDetails.usedHints.length>0" class="row">
							<div class="col-md-12">
								<h3 class="centered">
									Used Hints
									</h2>
									<table class="table">
										<thead>
											<tr>
												<th>#</th>
												<th>Category
												<th>Hint</th>
												<th>Score Impact</th>
											</tr>
										</thead>
										<tbody>
											<tr ng-repeat="h in userHistoryDetails.usedHints">
												<td>#{{$index +1}}</td>
												<td>{{h.type | capitalize}}</td>
												<td><div id="h{{h.id}}-md"
														ng-init="triggerHintsMarkdown(h)"></div></td>
												<td>{{h.scoreReducePercentage || "0"}}%</td>
											</tr>
										</tbody>
									</table>
							</div>
						</div>
						<div id="infoArea" class="row">
							<h3 class="centered">
								Results
								</h2>

								<div class="col-md-10">
									<table id="resultTable" class="table">
										<thead>
											<tr>
												<th>Flag</th>
												<th class="width12">Result</th>
												<th>Score</th>
												<th>Comment</th>
												<th ng-show="r.verified || r.automated"></th>
											</tr>
										</thead>
										<tbody>
											<tr ng-repeat="r in userHistoryDetails.results" big>
												<td class="verticalAlign">{{getQuestionName(r.name)}}</td>
												<td class="width12 center verticalAlign"><div
														class="padding5" ng-class="getStatusClass(r.status)">{{getStatusString(r.status)}}</div></td>
												<td class="right verticalAlign">{{getScoreString(r.score)}}/{{getQuestionMaxScore(r.name)}}</td>
												<td class="verticalAlign"
													ng-show="userHistoryDetails.status == 'STOPPED' || userHistoryDetails.status == 'REVIEWED'">{{r.verified
													&& r.comment || 'Pending review...'}}
													<div ng-repeat="i in r.userReportedIssues">
														<p class="marginBottom0 marginTop0">----------------</p>
														<p class="marginBottom0 marginTop0">
															<strong>From:</strong>{{i.fromPortal && "SecureFlag" || "User"}}
														</p>
														<p class="marginBottom0 marginTop0">
															<strong>Date:</strong> {{i.date}}
														</p>
														<p class="marginBottom0 marginTop0">
															<strong>Comment</strong>: {{i.text}}
														</p>
													</div>
												</td>
												<td class="verticalAlign"
													ng-show="userHistoryDetails.status == 'AUTOREVIEWED' || userHistoryDetails.status == 'REVIEWED_MODIFIED'">Automated
													review
													<div ng-repeat="i in r.userReportedIssues">
														<p class="marginBottom0 marginTop0">----------------</p>
														<p class="marginBottom0 marginTop0">
															<strong>From:</strong>{{i.fromPortal && "SecureFlag" || "User"}}
														</p>
														<p class="marginBottom0 marginTop0">
															<strong>Date:</strong> {{i.date}}
														</p>
														<p class="marginBottom0 marginTop0">
															<strong>Comment</strong>: {{i.text}}
														</p>
													</div>
												</td>
												<td class="verticalAlign center"
													ng-show="userHistoryDetails.status != 'STOPPED'"><button
														ng-click="openComplaintModal(userHistoryDetails.id,r.name)"
														class="btn btn-xs outline btn-primary">Not
														correct?</button></td>


											</tr>

										</tbody>
									</table>
								</div>

								<div class="col-md-2 centered marginTop3">
									<button ng-hide="zipError" id="viewDiffButton"
										ng-click="toggleCodeDiff()"
										class="btn btn-block btn-success outline historyButtons">
										Show/Hide<br /> Source Code Diff
									</button>

									<button ng-disabled="userHistoryDetails.feedback"
										ng-click="leaveFeedbackModal()"
										class="btn btn-block btn-info outline historyButtons">
										Give<br /> Feedback
									</button>
									<button ng-disabled="userHistoryDetails.status == 'STOPPED'"
										ng-click="downloadSolutions(userHistoryDetails.id)"
										class="btn btn-block outline btn-secondary historyButtons">
										View <br /> Exercise Solution
									</button>
								</div>
						</div>

						<div id="diffDiv" class="row" ng-show="showCodeDiff">
							<div class="col-md-12">
								<h3 class="">Source Code Diff:</h3>
								<div ng-show="emptyDiff">Source code diff is not
									available.</div>
								<div ng-non-bindable id="targetDiv"></div>
							</div>
						</div>
					</div>
				</div>
				<div id="scoringComplaintModal" class="modal fade" tabindex="-1"
					role="dialog">
					<div class="modal-dialog" role="document">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal"
									aria-label="Close">
									<span aria-hidden="true">&times;</span>
								</button>
								<h4 class="modal-title">Scoring Comment</h4>
							</div>
							<div class="modal-body">
								<p class="lead">
									Flag <small>"{{getQuestionName(complaintExerciseFlag)}}"</small>
								</p>
								<p>If you think this flag was not correctly scored, please
									provide your comment. Our team will review the exercise and
									provide feedback.</p>
								<textarea ng-model="complaintModalTextInput"
									class="feedbackTextArea"></textarea>
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-default"
									data-dismiss="modal">Close</button>
								<button type="button" ng-click="sendScoringComplaint()"
									class="btn btn-primary">Send</button>
							</div>
						</div>
					</div>
				</div>
				<div id="solutionModal" class="modal fade" tabindex="-1"
					role="dialog">
					<div class="modal-dialog modal-lg" role="document">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal"
									aria-label="Close">
									<span aria-hidden="true">&times;</span>
								</button>
								<h4 class="modal-title">Solution</h4>
							</div>
							<div class="modal-body paddingTop0">
								<div id="solutionMD"></div>
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-default"
									data-dismiss="modal">Close</button>
							</div>
						</div>
					</div>
				</div>
				<div id="leaveFeedbackModal" class="modal fade" tabindex="-1"
					role="dialog">
					<div class="modal-dialog" role="document">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal"
									aria-label="Close">
									<span aria-hidden="true">&times;</span>
								</button>
								<h4 class="modal-title">Feedback</h4>
							</div>
							<div class="modal-body">
								<p class="lead">Please provide your feedback about this
									exercise.</p>
								<textarea ng-model="feedbackMessage" class="feedbackTextArea"></textarea>
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-default"
									data-dismiss="modal">Close</button>
								<button type="button" ng-click="doLeaveFeedback()"
									class="btn btn-primary">Send</button>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<!-- *****************************************************************************************************************
	 ACHIEVEMENTS
	 ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="achievements"
			ng-show="visibility.achievements" ng-controller="achievements">
			<div class="container">
				<div class="right refreshTog hideCollapsed">
					<i ng-class="{'opacity02' : refreshing }" title="Refresh"
						ng-click="getUserStats()" class="fa fa-2x fa-history pointer"></i>
					<p class="marginTop0">
						<small>Refreshed at</br>
							{{getDateInCurrentTimezone(lastUpdated,'HH:mm (Z)')}}
						</small>
					</p>
				</div>
				<div class="row centered">
					<div class="inlineBlock marginLeft40">
						<h2 class="eblue">Achievements</h2>
					</div>

					<div class="widget-main-overview row hide990 font17">
						<div
							class="col-md-2 widgetAchievement col-md-offset-1 firstAchievementWidget">
							<div class="widget-overviewcard cursorDefault notransform">
								<div class="widget-overviewcard-icon">
									<img class="dashboardPicture"
										src="/assets/img/vulnerability.svg" />
								</div>
								<div class="widget-overviewcard-subtitle">Run Exercises</div>
								<div class="">
									<strong>{{userAchievements.exercisesRun}}</strong>
								</div>
							</div>
						</div>
						<div class="col-md-2 widgetAchievement">
							<div class="widget-overviewcard cursorDefault notransform">
								<div class="widget-overviewcard-icon">
									<img class="dashboardPicture" src="/assets/img/score.png" />
								</div>
								<div class="widget-overviewcard-subtitle">Points</div>
								<div class="">
									<strong>{{userAchievements.score}}</strong>
								</div>
							</div>
						</div>
						<div class="col-md-2 widgetAchievement">
							<div class="widget-overviewcard cursorDefault notransform">
								<div class="widget-overviewcard-icon">
									<img class="dashboardPicture" src="/assets/img/trophy.svg" />
								</div>
								<div class="widget-overviewcard-subtitle">Trophies</div>
								<div class="">
									<strong>{{nrTrophies}}</strong>
								</div>
							</div>
						</div>
						<div class="col-md-2 widgetAchievement">
							<div class="widget-overviewcard cursorDefault notransform">
								<div class="widget-overviewcard-icon">
									<img class="dashboardPicture" src="/assets/img/cert.svg" />
								</div>

								<div class="widget-overviewcard-subtitle">Certifications</div>
								<div class="">
									<strong>{{nrCertifications}}</strong>
								</div>
							</div>
						</div>
						<div class="col-md-2 widgetAchievement lastAchievementWidget">
							<div class="widget-overviewcard cursorDefault notransform">
								<div class="marginLeft5 widget-overviewcard-icon">
									<img class="dashboardPicture" src="/assets/img/placement.png" />
								</div>

								<div class="widget-overviewcard-subtitle">Tournament
									Badges</div>
								<div class="">
									<strong>{{nrPlacements}}</strong>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="noStatsForProfile"
					ng-show="emptyTrophy && emptyCertification && emptyPlacement && scorePerExercises.data[0].length==0 && remediationRatePerCategory.length==0 && remediatedPerCategory.data[0].length==0">
					There are no stats available for your profile yet.</div>

				<div class="row" ng-show="!emptyTrophy">
					<h3 class="sfblue marginTop25">Trophies</h3>
					<div class="card-deck-wrapper">
						<div class="card-deck" ng-repeat="tr in trophies">
							<div ng-repeat="t in tr"
								ng-class="getExerciseClass(t.achievement.technology)"
								class="card buttonify">
								<div class="card-header headerAchievement">{{t.achievement.technology}}</div>
								<img class="trophyListSVG svgMarginTop5" src="/assets/img/trophy.svg">
								<div class="card-block cardAchievement">
									<h6 class="card-title marginTop0 marginBottom0">{{t.achievement.name}}</h6>
									<p class="card-text marginTop0  ">
										<small class="text-muted">Awarded on
											{{getDateInCurrentTimezone(t.date, 'MMM D YYYY (HH:mm)')}}</small>
									</p>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="row" ng-show="!emptyCertification">
					<h3 class="sfblue marginTop25">Certifications</h3>
					<div class="card-deck-wrapper">
						<div class="card-deck" ng-repeat="cr in certifications">
							<div ng-repeat="t in cr"
								ng-class="getExerciseClass(t.achievement.technology)"
								class="card buttonify">
								<div class="card-header headerAchievement">{{t.achievement.technology}}</div>
								<img class="trophyListSVG" src="/assets/img/cert.svg">
								<div class="card-block cardAchievement">
									<h6 class="card-title marginTop0 marginBottom0">{{t.achievement.name}}
										({{t.achievement.difficulty}})</h6>
									<p class="card-text marginTop0">
										<small class="text-muted">Exp.:
											{{getDateInCurrentTimezone(t.achievement.expiration, 'MMM D
											YYYY')}}</small><small class="text-muted"> | Renewal:
											{{t.achievement.allowRenewal && 'Permitted' || 'Not
											permitted'}} </small>
									</p>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="row" ng-show="!emptyPlacement">
					<h3 class="sfblue marginTop25">Tournament Badges</h3>
					<div class="card-deck-wrapper">
						<div class="card-deck" ng-repeat="pl in placements">
							<div ng-repeat="t in pl"
								ng-class="getExerciseClass(t.achievement.technology)"
								class="card buttonify tournamentCard">
								<div class="card-header"></div>
								<img class="trophyListSVG tournamentListSVG"
									src="/assets/img/placement.png">
								<div class="card-block cardAchievement">
									<h6 class="card-title marginTop0 marginBottom0">
										{{t.achievement.name}}</h6>
									<small>Placement: {{t.achievement.placement}} </small>
									<p class="card-text marginTop0">
										<small class="text-muted">{{getDateInCurrentTimezone(t.date,
											'MMM D YYYY HH:mm')}}</small>
									</p>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div class="row " ng-show="scorePerExercises.data[0].length>0">
					<h2 class="centered eblue marginTop25">Stats</h2>

					<div ng-show="remediatedPerCategoryPercentage.labels.length>2">
						<h4 class="centered marginTop30 marginBottom20">Remediation
							Rate</h4>
						<div class="row a85PC">
							<canvas id="remediatedPerCategoryPercentage"
								class="chart chart-radar"
								chart-data="remediatedPerCategoryPercentage.data"
								chart-series="remediatedPerCategoryPercentage.series"
								chart-options="remediatedPerCategoryPercentage.options"
								chart-labels="remediatedPerCategoryPercentage.labels">
								</canvas>


						</div>
					</div>
					<h4 class="centered marginTop30 marginBottom20">Score and
						Duration by Exercise</h4>
					<div class="col-md-10 col-md-offset-1">
						<canvas id="remediatedScoreHistory" class="chart chart-line"
							chart-data="scorePerExercises.data"
							chart-labels="scorePerExercises.labels"
							chart-series="scorePerExercises.series"
							chart-dataset-override="scorePerExercises.datasetOverride"
							chart-options="scorePerExercises.options">
							</canvas>
					</div>
				</div>

				<div class="row left hideCollapsed" ng-show="remediationRatePerCategory.length>0">
					<h4 class="centered marginTop30 marginBottom20">Remediation
						Breakdown by Vulnerability Category</h4>

					<div class="row" class="inlineBlock">
						<div class="col-md-3 marginBottom10"
							ng-repeat="c in remediationRatePerCategory">
							<canvas width="203%" height="203%" class="chart chart-doughnut"
								chart-data="c.data" chart-options="c.options"
								chart-labels="c.labels">
									</canvas>
						</div>
					</div>
				</div>
				<div class="row" ng-show="remediatedPerCategory.data[0].length>0">
					<h4 class="centered marginTop30 marginBottom20">Time Spent by
						Vulnerability Category</h4>
					<div class="col-md-10 col-md-offset-1">
						<canvas id="remediatedPerCategory" class="chart chart-bar"
							chart-data="remediatedPerCategory.data"
							chart-series="remediatedPerCategory.series"
							chart-options="remediatedPerCategory.options"
							chart-labels="remediatedPerCategory.labels">
								</canvas>
					</div>
				</div>
			</div>
		</div>

		<!-- *****************************************************************************************************************
	 SETTINGS
	 ***************************************************************************************************************** -->
		<div class="standalone ng-cloak" id="settings"
			ng-show="visibility.settings" ng-controller="settings">
			<div class="container">
				<div class="row centered">
					<h2 class="eblue">Settings</h2>
					<form class="left" name="userProfileForm" novalidate>
						<div class="row">
							<div class="col-md-3">
								<h4>User Profile</h4>
							</div>
						</div>
						<div class="row">
							<div class="col-md-3">
								<h5>First Name</h5>
								<input class="fInput" required type="text" 
									ng-model="user.firstName">
							</div>
							<div class="col-md-3">
								<h5>Last Name</h5>
								<input class="fInput" required type="text"
									ng-model="user.lastName">
							</div>
							<div class="col-md-3">
								<h5>Email</h5>
								<input class="fInput" required type="email"
									ng-model="user.email">
							</div>
						</div>
						<div class="row">
							<div class="col-md-3">
								<h5>Country</h5>
								<ol class="nya-bs-select" required ng-model="user.country"
									data-size="20" data-live-search="true">
									<li nya-bs-option="ct in countries | orderBy:'name'"><a>
											{{ct.name}} <span class="glyphicon glyphicon-ok check-mark"></span>
									</a></li>
								</ol>
							</div>

						</div>
						<div class="row marginTop20">
							<div class="col-md-3">
								<button type="button"
									ng-disabled="userProfileForm.$error.required && !userProfileForm.$valid"
									ng-click="updateUserProfile()" class="btn btn-success">Save</button>
							</div>
						</div>
					</form>
					<form autocomplete="off" class="left" name="userPasswordForm"
						novalidate>
						<div class="row marginTop20">
							<div class="col-md-3">
								<h4>Change Password</h4>
							</div>
						</div>
						<div class="row ">
							<div class="col-md-3">
								<h5>Old Password</h5>
								<input autocomplete="off" class="fInput" name="oldPassword"
									required ng-model="oldPassword" type="password">
							</div>
							<div class="col-md-3">
								<h5>New Password</h5>
								<input autocomplete="off" complex-password name="newPassword"
									class="fInput" required type="password" ng-model="newPassword">
								<div
									ng-show="!userPasswordForm.$pristine && !userPasswordForm.newPassword.$valid">Use
									at least 8 characters including three of four groups in:
									numbers, symbols, capital letters, and lower-case letters.</div>
							</div>
							<div class="col-md-3">
								<h5>Repeat New Password</h5>
								<input autocomplete="off" class="fInput" type="password"
									name="newPasswordRepeat" ng-model="newPasswordRepeat" required
									compare-to="newPassword" />
								<div
									ng-show="!userPasswordForm.$pristine && !userPasswordForm.newPasswordRepeat.$valid">These
									password don't match. Try again?</div>
							</div>
						</div>
						<div class="row marginTop20">
							<div class="col-md-3">
								<button type="button"
									ng-disabled="userPasswordForm.$error.required || !userPasswordForm.newPasswordRepeat.$valid || !userPasswordForm.newPassword.$valid"
									ng-click="updateUserPassword()" class="btn btn-primary">Change</button>
							</div>
						</div>
					</form>
				</div>
				<form class="left" name="deleteAccountForm" novalidate>

					<div class="row marginTop20">
						<div>
							<h4>Delete Account</h4>
						</div>
					</div>
					<div class="row marginTop20 marginBottom20">

						<button type="button" ng-click="openRemoveModal()"
							class="btn btn-danger">Delete</button>
					</div>
				</form>
			</div>

			<div id="userRemoveModal" class="modal fade" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Delete Account</h4>
						</div>
						<div class="modal-body">
							<p class="lead">You are about to delete your account. This
								action is not reversible.</p>
						</div>
						<div class="modal-footer">
							<button ng-click="removeUser()" type="button"
								class="btn btn-danger" data-dismiss="modal">Delete
								Account</button>
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- *****************************************************************************************************************
	 FOOTER
	 ***************************************************************************************************************** -->
	<div id="sffooter" class="sfFooterN">
			<div class="marginLeft10">
			<a class="sfFooterLink" href="mailto:community@secureflag.com">community@secureflag.com</a>
			</div>
			<div class="marginRight10 hideCollapsed">
				<p class="sfFooterLink">© 2020 SecureFlag</p>
			</div>

		</div>
	<div class="waitLoader"></div>

	<script src="/assets/js/libu.min.js"></script>
	<script src="/user/js/user.js"></script>

</body>
</html>